/**
 *
 * Wechaty: Wechat for Bot. and for human who talk to bot/robot
 *
 * Class StateSwitch
 * Licenst: Apache-2.0
 * https://github.com/zixia/state-switcher
 *
 * Helper Class for Manage State Change
 */
/**
 * A - State A
 * B - State B
 */
export declare class StateSwitch<A, B> {
    private _client;
    private _target;
    private _current;
    private _stable;
    private log;
    constructor(_client: string, initState: A | B, logInstance?: any);
    setLog(logInstance?: any): void;
    /**
     * set/get target state
     */
    target(newState?: A | B): A | B;
    /**
     * set/get current state
     * @param stable boolean  true for stable, false for inprocess
     */
    current(newState?: A | B, stable?: boolean): A | B;
    /**
     * does the current state be stable(not inprocess)?
     */
    stable(): boolean;
    /**
     * does the current state be inprocess(not stable)?
     */
    inprocess(): boolean;
    /**
     * get the client name
     */
    client(): string;
}
export default StateSwitch;
